#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commctrl.h>

#define NUM_BUTTONS 20	// -   
HWND hWndTB;			//    

LRESULT CALLBACK WndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) {
		case WM_CREATE:
		{
			CREATESTRUCT* cs = (CREATESTRUCT*) lParam;
			//   ComCtl32.dll
			INITCOMMONCONTROLSEX icex;
			icex.dwSize = sizeof (INITCOMMONCONTROLSEX);
			icex.dwICC  = ICC_BAR_CLASSES;
			InitCommonControlsEx (&icex);
			//   
			hWndTB = CreateWindowEx (0, TOOLBARCLASSNAME, NULL,
				WS_CHILDWINDOW | WS_VISIBLE | CCS_TOP,
				0, 0, 0, 0, hWnd, (HMENU) 100, cs->hInstance, NULL);
			//     Windows
			SendMessage (hWndTB, TB_LOADIMAGES, IDB_STD_SMALL_COLOR, (LPARAM) HINST_COMMCTRL);
			//     
			SendMessage (hWndTB, TB_BUTTONSTRUCTSIZE, sizeof (TBBUTTON), 0);
			TBBUTTON tbb [NUM_BUTTONS];
			ZeroMemory (&tbb, sizeof (tbb));
			for (int i = 0; i < NUM_BUTTONS; ++i)
				if (i & 1) {
					//  
					tbb [i].iBitmap = i / 2;
					tbb [i].idCommand = 200;
					tbb [i].fsState = TBSTATE_ENABLED;
					tbb [i].fsStyle = BTNS_BUTTON; 
				} else {
					//  
					tbb [i].iBitmap = I_IMAGENONE;
					tbb [i].fsState = TBSTATE_ENABLED; 
					tbb [i].fsStyle = TBSTYLE_SEP; 
				}
			SendMessage (hWndTB, TB_ADDBUTTONS, NUM_BUTTONS, (LPARAM) &tbb);
			SendMessage (hWndTB, TB_AUTOSIZE, 0, 0);
			return 0;
		}

		case WM_SIZE:
			//        
			SendMessage (hWndTB, message, wParam, lParam);
			break;

		case WM_COMMAND:
			//     
			if (LOWORD (wParam) == 200) {
				//    
				for (int i = 0; i < NUM_BUTTONS; i += 2)
					SendMessage (hWndTB, TB_MOVEBUTTON, i, i + 1);
				SendMessage (hWndTB, TB_AUTOSIZE, 0, 0);
			}
			break;

		case WM_PAINT:
			//  
			if (GetUpdateRect (hWnd, NULL, FALSE)) {
				PAINTSTRUCT ps;
				BeginPaint (hWnd, &ps);
				EndPaint (hWnd, &ps);
			}
			return 0;

		case WM_DESTROY:
			PostQuitMessage (0);
			return 0;
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
}

int APIENTRY WinMain (HINSTANCE hInstance, HINSTANCE, LPTSTR, int)
{
	//   
	WNDCLASSEX wcex;
	ZeroMemory (&wcex, sizeof (wcex));
	wcex.cbSize = sizeof (WNDCLASSEX); 
	wcex.style = CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc = WndProc;
	wcex.hInstance = hInstance;
	wcex.hIcon = LoadIcon (NULL, IDI_ASTERISK);
	wcex.hCursor = LoadCursor (NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	wcex.lpszClassName = "lb041217";
	if (RegisterClassEx (&wcex)) {
		//  
		HWND hWnd = CreateWindowEx (WS_EX_APPWINDOW,
			wcex.lpszClassName, wcex.lpszClassName,
			WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS | WS_VISIBLE,
			CW_USEDEFAULT, CW_USEDEFAULT, 600, 400,
			GetDesktopWindow (), NULL, hInstance, NULL);
		if (hWnd) {
			//  
			ShowWindow (hWnd, SW_NORMAL);
			UpdateWindow (hWnd);
			//   
			MSG msg;
			while (GetMessage (&msg, NULL, 0, 0)) {
				TranslateMessage (&msg);
				DispatchMessage (&msg);
			}
		}
	}
	return 0;
}
